#include "forest.h"
#include <ctime>

void forest::reduce_flavour(){
        for(int i=0;i<height;i++){
               for(int j=0;j<width;j++){
                       this->flavour[i][j]*=this->flavour_fraction;
               }
        }
}

float forest::get_flavour(int i, int j){
                if(i<0){i=this->width-1;}
                if(j<0){j=this->height-1;}
                i=i%this->width;
                j=j%this->height;
		return this->flavour[i][j];
}

forest::forest(int w, int h){
	srand(time(NULL));
	this->width=w;
	this->height=h;
	this->home_x=w/2;
	this->home_y=h/2;
	this->flavour = new float*[w];
	this->occupied = new bool*[w];
	for(int i=0;i<this->width;i++){
		this->flavour[i]=new float[h];
		this->occupied[i]=new bool[h];
               for(int j=0;j<this->height;j++){
			this->flavour[i][j]=(float)rand()/(float)RAND_MAX*0.1;
			this->occupied[i][j]=false;
               }
	}

}

float forest::flavour_fraction=999./1000.;

void forest::paint(){
	glBegin(GL_POINTS);
        for(int i=0;i<this->height;i++){
               for(int j=0;j<this->width;j++){
			float color=this->flavour[i][j];
			glColor3f(color,color,0.);
			glVertex2f(i+10,j+10);	
               }
        }
	glEnd();
	glBegin(GL_LINES);
	glColor3f(1.0,1.0,1.0);
	glVertex2f(9,9);
	glVertex2f(this->width+10,9);
	glVertex2f(this->width+10,9);
	glVertex2f(this->width+10,this->height+10);
	glVertex2f(this->width+10,this->height+10);
	glVertex2f(9,this->height+10);
	glVertex2f(9,this->height+10);
	glVertex2f(9,9);
	glEnd();
}


